package etomo.process;

/**
 * <p>Description: </p>
 * 
 * <p>Copyright: Copyright 2008</p>
 *
 * <p>Organization:
 * Boulder Laboratory for 3-Dimensional Electron Microscopy of Cells (BL3DEMC),
 * University of Colorado</p>
 * 
 * @author $Author: sueh $
 * 
 * @version $Revision: 1.1 $
 * 
 * <p> $Log: FailureReason.java,v $
 * <p> Revision 1.1  2009/04/13 22:29:41  sueh
 * <p> bug# 1207 Made class available to other classes.
 * <p> </p>
 */
public final class FailureReason {
  public static final String rcsid = "$Id: FailureReason.java,v 1.1 2009/04/13 22:29:41 sueh Exp $";

  static final FailureReason UNKOWN = new FailureReason("",
      "Unable to get the load averages for this computer.");
  static final FailureReason COMPUTER_DOWN = new FailureReason("down",
      "This computer in not running.");
  static final FailureReason LOGIN_FAILED = new FailureReason("no login",
      "You must have an account on this computer.  "
          + "You must also have a passwordless login on this computer.");

  private final String reason;
  private final String tooltip;

  private FailureReason(String reason, String tooltip) {
    this.reason = reason;
    this.tooltip = tooltip;
  }

  public String getReason() {
    return reason;
  }

  public String getTooltip() {
    return tooltip;
  }

  public String toString() {
    return reason;
  }
}