package etomo.process;

import etomo.ApplicationManager;
import etomo.comscript.ConstTiltParam;
import etomo.type.AxisID;
import etomo.type.ProcessName;

/**
 * <p>Description: for processes TILT_3dFIND and TILT_3dFIND_REPROJECT.  Cannot
 * reconnect.</p>
 * 
 * <p>Copyright: Copyright 2008</p>
 *
 * <p>Organization:
 * Boulder Laboratory for 3-Dimensional Electron Microscopy of Cells (BL3DEMC),
 * University of Colorado</p>
 * 
 * @author $Author: sueh $
 * 
 * @version $Revision: 1.1 $
 * 
 * <p> $Log: Tilt3dFindProcessMonitor.java,v $
 * <p> Revision 1.1  2009/09/21 17:52:28  sueh
 * <p> bug# 1267 A monitor for tilt_3dfind.  Tilt_3dfind doesn't reconnect so it is
 * <p> simpler to use a separate monitor.  The only thing that is overridden is how
 * <p> to get the TiltParam.  It this case it is passed in.
 * <p> </p>
 */
final class Tilt3dFindProcessMonitor extends TiltProcessMonitor {
  public static final String rcsid = "$Id: Tilt3dFindProcessMonitor.java,v 1.1 2009/09/21 17:52:28 sueh Exp $";

  private final ConstTiltParam tiltParam;

  public Tilt3dFindProcessMonitor(final ApplicationManager appMgr, final AxisID id,
      final  ProcessName processName, final ConstTiltParam tiltParam) {
    super(appMgr, id, processName);
    this.tiltParam = tiltParam;
  }
  
  /**
   * Returns the instance of TiltParam that was passed into the constructor.
   * @return
   */
  ConstTiltParam getTiltParam() {
    return tiltParam;
  }
}
