package etomo.process;

/**
 * <p>Description: </p>
 * 
 * <p>Copyright: Copyright 2006</p>
 *
 * <p>Organization:
 * Boulder Laboratory for 3-Dimensional Electron Microscopy of Cells (BL3DEMC),
 * University of Colorado</p>
 * 
 * @author $Author: sueh $
 * 
 * @version $Revision: 1.1 $
 * 
 * <p> $Log: UncaughtException.java,v $
 * <p> Revision 1.1  2006/10/11 10:11:50  sueh
 * <p> bug# 938 Making ThreadGroup dependent on UncaughtException instead of
 * <p> UITest, so that it does not require JfcUnit to compile.
 * <p> </p>
 */
public final class UncaughtException {
  public static final String rcsid = "$Id: UncaughtException.java,v 1.1 2006/10/11 10:11:50 sueh Exp $";

  public static final UncaughtException INSTANCE = new UncaughtException();

  private Throwable throwable = null;

  private UncaughtException() {
  }

  public void setThrowable(Throwable throwable) {
    this.throwable = throwable;
  }

  public String getThrowableString() {
    String message = null;
    synchronized (this) {
      if (throwable != null) {
        message = throwable.getMessage();
        throwable = null;
      }
    }
    return message;
  }
}
