package etomo.storage;

import java.io.File;
import java.io.FileFilter;

/**
 * <p>Description: </p>
 * 
 * <p>Copyright: Copyright 2006</p>
 *
 * <p>Organization:
 * Boulder Laboratory for 3-Dimensional Electron Microscopy of Cells (BL3DEMC),
 * University of Colorado</p>
 * 
 * @author $Author: sueh $
 * 
 * @version $Revision: 1.1 $
 * 
 * <p> $Log: ComFileFilter.java,v $
 * <p> Revision 1.1  2007/05/03 00:46:38  sueh
 * <p> bug# 964 Accepts .com files starting with rootname-
 * <p> </p>
 */

public final class ComFileFilter implements FileFilter {
  public static final String rcsid = "$Id: ComFileFilter.java,v 1.1 2007/05/03 00:46:38 sueh Exp $";

  private final String rootName;

  public ComFileFilter(String rootName) {
    this.rootName = rootName;
  }

  /**
   * returns true if the file is a file and ends in .com
   * This is for automatically deleting files, not looking at a file dialog, so
   * directories should not be included 
   */
  public boolean accept(File file) {
    if (file.isDirectory()) {
      return false;
    }
    String name = file.getName();
    if (!name.startsWith(rootName + "-") || !name.endsWith(".com")) {
      return false;
    }
    return true;
  }

  public String getDescription() {
    return "Comscripts (.com)";
  }
}
