package etomo.storage;

import java.io.File;

import javax.swing.filechooser.FileFilter;

/**
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2002, 2003, 2004</p>
 *
 * <p>Boulder Laboratory for 3-Dimensional Electron Microscopy of Cells (BL3DEM),
 * University of Colorado</p>
 *
 * @author $$Author: sueh $$
 *
 * @version $$Revision: 1.1 $$
 *
 * <p> $$Log: MtfFileFilter.java,v $
 * <p> $Revision 1.1  2004/04/13 17:21:02  sueh
 * <p> $bug# 409 mtf file dialog filter ".mtf"
 * <p> $$ </p>
 */
public class MtfFileFilter extends FileFilter {
  public static final String rcsid = "$$Id: MtfFileFilter.java,v 1.1 2004/04/13 17:21:02 sueh Exp $$";

  /**
   * @see javax.swing.filechooser.FileFilter#accept(File)
   */
  public boolean accept(File f) {
    //  If this is a file test its extension, all others should return true
    if (f.isFile() && !f.getAbsolutePath().endsWith(".mtf")) {
      return false;
    }
    return true;
  }

  /**
   * @see javax.swing.filechooser.FileFilter#getDescription()
   */
  public String getDescription() {
    return "MTF File";
  }
}
