package etomo.type;

import java.io.File;

/**
 * <p>Description: </p>
 * 
 * <p>Copyright: Copyright 2010</p>
 *
 * <p>Organization:
 * Boulder Laboratory for 3-Dimensional Electron Microscopy of Cells (BL3DEMC),
 * University of Colorado</p>
 * 
 * @author $Author: sueh $
 * 
 * @version $Revision: 1.1 $
 * 
 * <p> $Log: ToolsMetaData.java,v $
 * <p> Revision 1.1  2010/02/17 04:50:15  sueh
 * <p> bug# 1301 Meta data for tools.
 * <p> </p>
 */
public final class ToolsMetaData extends BaseMetaData {
  public static final String rcsid = "$Id: ToolsMetaData.java,v 1.1 2010/02/17 04:50:15 sueh Exp $";

  private final DialogType dialogType;
  private final ToolType toolType;

  private String rootName = null;

  public ToolsMetaData(DialogType dialogType, ToolType toolType) {
    this.dialogType = dialogType;
    this.toolType = toolType;
    axisType = AxisType.SINGLE_AXIS;
  }

  String createPrepend(String prepend) {
    return null;
  }

  public String getDatasetName() {
    return rootName;
  }

  public void setRootName(File file) {
    rootName = file.getName();
  }

  public String getMetaDataFileName() {
    //Tools projects are not saved
    return null;
  }

  public String getName() {
    if (rootName == null) {
      return toolType.toString();
    }
    return rootName;
  }

  public boolean isValid() {
    return validate() == null;
  }

  /**
   * returns null if valid
   * @return error message if invalid
   */
  public String validate() {
    if (rootName == null) {
      return "Missing root name.";
    }
    return null;
  }
}
