.na
.nh
.TH finishjoin 1 3.4.12 BL3DEMC
.SH NAME
finishjoin \- Join serial section tomograms after finding alignments
.SH SYNOPSIS
finishjoin [options] root_name  slice_range1  slice_range2  ...
.SH DESCRIPTION
finishjoin will complete the operations required to join serial section
tomograms together, after one has made a command file with "makejoincom", run
the command file, and found alignments between the tomograms.  "root_name"
is the root name for various intermediate files and the joined tomogram, as
already specified to "makejoincom".  The command line must also have a slice
range to include from each individual tomogram.  Enter the starting and ending
slice numbers of the desired ranges, separated by a comma.  Slices
are numbered from 1.
.SS Options
Options may be abbreviated to a single letter.

.TP
.B -ref <tomogram #>
Make the given tomogram be the reference for alignment, in which case slices
from it will not be transformed, and other tomograms will be transformed into
alignment with it.  By default, all tomograms will be transformed into
alignment to a position averaged over all tomograms with similar orientations.
.TP
.B -angle <range>
Base the average alignment on tomograms whose rotation angles fall within
the given range of each other (default 50 degrees).  If a minority of the
tomograms are rotated by large angles like 90 or 180 degrees relative to the
rest, then they will be excluded when determining the average alignment.  This
prevents all of the sections from being rotated to an intermediate orientation.
.TP
.B -size <X,Y>
Set the size of the output slices to X by Y pixels.  The default size will
be the maximum X size by the maximum Y size of the input tomograms.
.TP
.B -offset <X,Y>
Set the X and Y offsets for the output slices.  These follow the same
sign convention as in newstack; namely, the numbers entered should be the
offsets from the center of the current image to the image point which is
intended to end up in the center of the output image.  A positive offset in
X will thus shift the image to the left.
.TP
.B -trial <interval>
Build a trial joined tomogram using only slices at the given interval.  The
first and last slice of each slice range will always be included.  The output
file will be named "root_name"_trial.join.
.TP
.B -bin #
Bin images by the given value when building a trial joined tomogram.  The
.B -size
and
.B -offset
entries, if any, should be entered in unbinned pixels; i.e., they do not need
to be changed when selecting binning.
This
option has no effect if the
.B -trial
option is not entered.
.TP
.B -local
When running Xftoxg(1) on the primary alignment transforms, run the program in
its default mode, which does local fits to 7 adjacent sections.  This option
may eliminate unwanted trends in data sets with many sections.  When it is not
entered, Xftoxg(1) is run with "-nfit 0", which computes a global alignment.  
.TP
.B -xform <file>
Use the refinement transforms contained in the given file to compute the
transforms to apply to the tomograms.  The file should contain global
transforms as computed by Xfjointomo(1).
.TP
.B -maxsize
Just compute the maximum size and offsets needed to contain the transformed
images from all of the sections, given the current transformations.  No
image file will be created.
.TP
.B -gaps
Create blank slices when the slice ranges include values out of bounds 
(below 1 or above the number of slices in the file).  This option can be used
to make the gap between two sections bigger than what would be provided by
simply stacking all the slices from each file.
Without this option, values out of bounds are not allowed.
.TP 
.B -P
Output process ID.
.SH FILES
The program assumes the existence of several files with the given root name,
especially "root_name".info and "root_name".xf.
.SH AUTHOR
David Mastronarde  <mast@colorado.edu>
