.na
.nh
.TH imodfillin 1 2.6.2 BL3DEMC
.SH NAME
imodfillin \- fill in missing contours in IMOD model using mesh data
.SH SYNOPSIS
imodfillin [options] <input model> <output model>
.SH DESCRIPTION
imodfillin will fill in contours in an IMOD model on sections that were
skipped during modeling.  It interpolates a contour between existing ones
using information in the object mesh
created by imodmesh(1).  Each interpolated contour will fall on the surface
connecting existing contours.  It is thus necessary to run imodmesh(1) before
imodfillin.  Since you need to have a mesh between contours on non-adjacent 
sections, you should use one or more imodmesh options to connect across gaps in
the data.  If sections have either a complete set of contours or no contours 
at all, then the
.B -s
option will suffice.  If the pattern is less rigid than this, use the 
.B -P
option in addition (or exclusively), where the
number of passes that you specify with this option 
equals the maximum number of sections of separation between contours that
you wish to connect.  Do not use any imodmesh option that would set the z 
increment
to greater than 1 (i.e.,
.B -l, -i,
or
.B -z
), for then imodfillin will probably create contours on sections that
already have them.
.P
By default, the program will attempt to fill in all closed-contour objects
that have meshes, but will skip open-contour objects.  Use the 
.B -o
option to specify a subset of objects to be done, or to force it to do 
particular open-contour objects.
.P
The created contours will inherit any surface or time information contained
in the meshes.  If your original contours have surface numbers, be sure to
mesh with the 
.B -S
option to preserve this surface information in the meshes, so that the
interpolated contours will have the same surface numbers as the original ones.
.SS Options
.TP
.B -e
Place new contours in existing objects.  Use this option if you do not
plan to check and modify the interpolated contours.
.TP 
.B -n
Place new contours in new objects; this is the default, so that contours
can be checked conveniently.  One new object
will be created for each object that is being filled in.  These contours
may be moved into the proper object either one by one or all at once via
the Edit-Contour-Move dialog and M hotkey in 3dmod(1).
.TP
.B -o <list>
Do operations only on objects in the list of numbers.  The list can consist
of comma-separated ranges (e.g., 1,7-11,13-17,19).
Without this option, all closed contour objects with meshes are filled in.
.TP
.B -i <value>
Set the Z increment for filling in contours.  This option has two effects:
the program will fill in only gaps that are wider than the given value,
and it will insert new contours at this given Z increment instead of on every
section.
.TP
.B -R <value>  
Resolution or tolerance for point reduction
in the generated contours.  Points are eliminated if they are within this
distance of the lines connecting the remaining points, just as with the -R
option in imodmesh(1).
Values in the range 0.25 to 0.5 are often useful.
.SH FILES
If the model file already exists, it becomes a backup file with ~ added to its
name.
.SH AUTHOR
David Mastronarde
.SH SEE ALSO
3dmod(1), imodmesh(1)
.SH BUGS
Email bug reports to mast@colorado.edu.
