.na
.nh
.TH mrcbyte 1 2.42 BL3DEMC
.SH NAME
mrcbyte \- Converts an MRC file into byte type data.
.SH SYNOPSIS
mrcbyte -[rRblecsxyz] <infile> <outfile>
.SH DESCRIPTION
mrcbyte will convert MRC files to an MRC byte type file.  The
default is to convert the entire file with a full linear ramp
and write the output to byte type data.  With appropriate options,
the intensity scaling can be modified to match the scaling achieved when 
viewing the file in 3dmod(1).  Subsets of the image can also be copied.
Complex data will also be scaled just as when loaded into 3dmod, so this
program can be used to save a viewable form of a Fourier transform as bytes.
.SS Options
.TP
.B -c <black,white>
Specify intensity scaling to match the scaling achieved with the given
black and white contrast settings in 3dmod(1).
.TP
.B -s <min,max>
Specify an initial intensity scaling, which will scale "min" to 0 and
"max" to 255, just as is achieved with the 
.B -s
option in 3dmod.  If both
.B -c
and
.B -s
are entered, the final scaling will be the product of these two scalings.
.TP
.B -l
Use logarithmic scaling (valid for short integer and floating point data).
.TP
.B -e
Use exponential scaling (valid for short integer and floating point data).
.TP
.B -R
Reverse contrast in the output.
.TP
.B -x <X0,X1>
Write out pixels in X between X0 and X1, inclusive, numbered from 0.
.TP
.B -y <Y0,Y1>
Write out pixels in Y between Y0 and Y1, inclusive, numbered from 0.
.TP
.B -z <Z0,Z1>
Write out pixels in Z between Z0 and Z1, inclusive, numbered from 0.
.TP
.B -b
Write raw byte data without a header.
.TP
.B -r
Request user input for the contrast and size options.
.SH EXAMPLES
.nf
Example of a manual mrc resizing operation.

% mrcbyte -r image.mrc byte.mrc 
Enter (min x, max x). (return for default) >10 100
Enter (min y, max y). (return for default)  >10 100
Enter sections (low, high)  >0 1
Enter (black level, white level) >34 200

Converting Image # 002

Example of a command that does the same thing.

% mrcbyte -x 10,100 -y 10,100 -z 0,1 -c 34,200 image.mrc byte.mrc
.fi	
.SH BUGS
There is no protection against taking the log of numbers <= 0 or taking
exponentials of numbers that are too large.

.SH AUTHORS
Jim Kremer and David Mastronarde  <mast@colorado.edu>
.SH SEE ALSO
3dmod(1), trimvol(1), newstack(1)
