.na
.nh
.TH patch2imod 1 2.42 BL3DEMC
.SH NAME
patch2imod \- makes model from patch displacement or residual file
.SH SYNOPSIS
patch2imod [options] <patch file> <IMOD model file>
.SH DESCRIPTION
patch2imod creates an IMOD model from a file containing 3-D displacements at
a series of positions, such as the patch file generated by corrsearch3d(1).
Each displacement will be represented by a vector starting at the position
of the patch, and whose magnitude and direction are determined by the 3-D
displacement multiplied by a scale factor.  These vectors are simply open
contours consisting
of two points.  In addition, if the patch file contains correlation
coefficients or residual values, these values will be stored in the model.
.P
The resulting model can be viewed to determine the location of patches with 
aberrant displacements and even edited to remove such patches.  The
easiest way to do this is to start 3dmod with just the model file and no
image file, open the model view window, and use the right mouse button in
the model view window to select vectors that differ greatly from 
their neighbors.  The currently selected vector(s) will be highlighted by
being thicker.
They may then be deleted with the D hot key.  The edited
model can be converted back to a patch file with imod2patch(1).
.P
The correlation or residual values can be visualized by opening the "Values"
panel in the model view Object Edit window and selecting "Show stored values".
The color display can be manipulated and subsets of vectors can be selected.
.P
If the patch file contains a column of numbers after the correlation
coefficient or residual values, these will
also be stored in the model but cannot be visualized.  They will be
output to a new patch file by imod2patch(1). 
.P
One can also
read the model in on top of a tomogram; by default it is marked as flipped so
that it will display correctly on tomograms in their original orientations.
.P
The scaling is stored as the pixel size in the model header.  Do not change
this value, or imod2patch will not be able to convert the displacements back
correctly.
.P
The program will also convert a list of 2-D residuals produced by tiltalign(1).
In this case, the model is not marked as flipped, so that it can be displayed
on top of the original image file.
.SS Options
.TP
.B -s <value>
Change the vector length scaling to the given value; the default is 10.
.TP
.B -f
Do not flip Y and Z coordinates in the model.  Use this option to display the
model on a tomogram that has been flipped or rotated from its original
orientation.
.TP
.B -c <size>
Include four clipping planes in the model to enclose a square area of the
given size in the center of the model.  These planes will not be on by default,
but can be turned on and manipulated together in the model view Object Edit
window.  These planes could be helpful for seeing a subset of vectors when the
model is rotated.
.TP
.B -n <name>
Give this name to the model object.  The name is useful for indicating what
kind of values are stored with the vectors.
.TP
.B -z
Ignore zero values when computing the mean and SD of values.  The program
computes the actual maximum value and the mean and SD, and then stores a
maximum value that is limited to 10 SDs above the mean.  This stored value
determines the maximum that is shown in the model view object edit window of
3dmod.  This option is needed when there a very large numbers of zero values.
.SH FILES
If the model file already exists, it becomes a backup file with ~ added to its
name.
.SH AUTHOR
David Mastronarde
.SH SEE ALSO
imod2patch(1), patchcrawl3d(1), patchcorr3d(1), 3dmod(1), 3dmodv(1),
findwarp(1), refinematch(1), tiltalign(1)
.SH BUGS
Email bug reports to mast@colorado.edu.
