.na
.nh
.TH patchcorr3d 1 2.30 BL3DEMC
.SH NAME
patchcorr3d \- Correlate a series of local patches from two volumes
.SH SYNOPSIS
patchcorr3d xsize ysize zsize  nx ny nz  xlo xhi ylo yhi \\
       zlo zhi filea fileb [transform_file original_fileb]
.SH DESCRIPTION
patchcorr3d will determine the 3-D displacement between the two image volumes
in filea and fileb, at a regular array of positions.  At each position, it
extracts a patch from each of the two 
volumes using tapervoledge.  It then uses clip to do 3-D cross-correlation
between the patches and determines the displacement of the patch in fileb
relative to the patch in filea.

The program outputs an initial line with the total number of patches, then
one line for each patch, containing the X, Y, and Z coordinates of the patch 
and the displacement between the two files in X, Y, and Z.

.SH ARGUMENTS
The size of the patches in X, Y, and Z is set by the arguments xsize, ysize, 
and zsize.

The number of patches in X, Y, and Z is set by the arguments nx, ny, and nz.

The lower and upper limits of the region from which patches will be extracted 
are set by xlo and xhi in X, ylo and  yhi in Y, and zlo and zhi in Z.  

In addition, the region can be limited further if fileb was transformed from
an original volume and appreciably shifted by that transformation.  If the
optional arguments transform_file and original_fileb are included, then the
limits of the region for patches will be adjusted to exclude domains in fileb
that back-transform to coordinates
outside the bounds of the original fileb.

.SH AUTHOR
David Mastronarde  <mast@colorado.edu>
.SH SEE ALSO
tapervoledge(1), clip(1)
