.na
.nh
.TH splitcombine 1 3.4.1 BL3DEMC
.SH NAME
splitcombine \- Produce command files for running volcombine in parallel
.SH SYNOPSIS
splitcombine [Combine command file] [Temporary directory]
.SH DESCRIPTION
splitcombine will take a command file for combining pieces from two 
dual-axis tomograms and
produce multiple command files that can be run in parallel by
Processchunks(1).  The arguments are optional.  If no arguments are entered,
the program will
operate on volcombine.com, producing volcombine-start.com to do initial tasks,
volcombine-NNN.com to produce individual pieces (e.g., volcombine-027.com to
produce sum27.rec), and volcombine-finish.com to reassemble the pieces and
clean up intermediate files.
.P
The program will modify the components of volcombine.com to place temporary
files other than sum*.rec in a local temporary directory appropriate for
the machine running the command file.  If you do not specify such a directory 
as an optional second argument, it will either be one
defined by the environment variable IMOD_TMPDIR, or /usr/tmp if it exists,
or /tmp.  The local temporary directory is important for reducing network
traffic and access of all machines to
the same working directory.  This temporary directory need not be accessible
to all machines, and is distinct from the
temporary directory that you can set up to do the combine operation in, which
will be referred to as the master temporary directory.  The latter must be
accessible from all machines.
If volcombine.com was set up to use
a master temporary
directory in /localscratch, it will replace these references
with "/scratch/machine_name", in keeping with the scratch file system setup in
the BL3DEMC.  However, if you set up your combine with a master temporary 
directory
in /usr/tmp or /tmp, other machines will not be able to access this directory
and the program will warn you that the operation cannot be run on multiple
machines.
.P
The first optional argument can be used to specify a command file name other
than volcombine.com.  The second optional argument can be used to specify
a local temporary directory other than the default for 
each individual remote machine.
There is one other option: "-h" to get a usage statement from the program.
.SH FILES
The finishing command file deletes the sum*.rec, as well as all
command and log files for the pieces.
.SH AUTHOR
David Mastronarde  <mast@colorado.edu>
.SH SEE ALSO
processchunks(1)
