.na
.nh
.TH squeezevol 1 2.41 BL3DEMC
.SH NAME
squeezevol \- Reduce a volume in all dimensions by interpolation.
.SH SYNOPSIS
squeezevol [options] <input file>  <output file>
.SH DESCRIPTION
squeezevol provides a 
command-line interface to the program matchvol, for reducing (or expanding)
an image volume in size in all dimensions by 3-D interpolation.
There are options for specifying the overall scaling factor, independent 
scaling factors for each dimension, and the extent of the input volume to
be scaled.  The size of the output volume is automatically set to the 
appropriate size to contain the scaled input volume.  There is a default
global scaling factor, which is reported by the program in its "usage" output.
The factors are referred to as "squeezing" factors because the volume is 
actually scaled by the inverse of each factor.
.SS Options
.TP
.B -f <factor>
Set the overall squeezing factor to "factor".
.TP
.B -x <factor>
Squeeze by "factor" in the X dimension.
.TP
.B -y <factor>
Squeeze by "factor" in the Y dimension.
.TP
.B -z <factor>
Squeeze by "factor" in the Z dimension.
.TP
.B -ix <size>
Squeeze "size" pixels in the X dimension, centered on the middle in X.
.TP
.B -iy <size>
Squeeze "size" pixels in the Y dimension, centered on the middle in Y.
.TP
.B -iz <size>
Squeeze "size" pixels in the Z dimension, centered on the middle in Z.
.TP
.B -l
Use linear interpolation when transforming the volume, instead of the default
quadratic interpolation.
.TP 
.B -P
Output process ID.
.TP
.B -t <temporary directory>
Path name of directory into which matchvol can place temporary files.
.SH FILES
If the output file already exists a backup image
of the original is created
with the ~ extension.
.SH AUTHOR
David Mastronarde  <mast@colorado.edu>
.SH SEE ALSO
matchvol(1)
