.na
.nh
.TH trimvol 1 2.30 BL3DEMC
.SH NAME
trimvol \- Trim a volume and scale it to bytes.
.SH SYNOPSIS
trimvol [options] <input file>  <output file>
.SH DESCRIPTION
Trimvol provides a command-line interface to the programs Findcontrast(1) and
Newstack(1), for copying a selected portion of an MRC image volume into a new
file, with automatic scaling to bytes.  
There are options for specifying the volume to be extracted, and for 
controlling the scaling to bytes.  There is also an option to scale 
floating point numbers to integers.
By default, coordinates are numbered from 1.

If you use the 
.B -sz
or 
.B -s 
option, then Findcontrast(1) will be run on the specified sections.  By
default, regions
within 10% of the lateral borders of each section are omitted, but a different
region can be set with
.B -sx
and
.B -sy.
A scaling is
chosen which saturates the intensities of one pixel per slice, on average, at
the dark and the light end.  If you use 
.B -sz
then coordinates specified with these options will be treated as coming from 
a flipped volume only if the
.B -f
option is entered.  If you use
.B -s
then coordinates will always be taken as coming from a flipped volume.

By default, the origin of the output file will be adjusted so that a model
built on the input volume will display correctly on the output file.  This
will even work for a volume rotated with
.B -rx
but not for one flipped with
.B -yz.
This adjustment can be turned off with the 
.B -k
option.

.SS Options
You can enter only one of
.B -c,
.B -s,
.B -sz
or
.B -mm.
Similarly, you cannot enter both
.B -x
and
.B -nx,
both
.B -y
and
.B -ny,
or both
.B -z
and
.B -nz.
You can also enter only one of 
.B -sz
and
.B -s
and only one of 
.B -yz
and
.B -rx.
.TP
.B -x <X0,X1>
Copy pixels in X between X0 and X1, inclusive.
.TP
.B -y <Y0,Y1>
Copy pixels in Y between Y0 and Y1, inclusive.
.TP
.B -z <Z0,Z1>
Copy pixels in Z between Z0 and Z1, inclusive.
.TP
.B -nx <size>
Copy "size" pixels in the X dimension, centered on the middle in X.
.TP
.B -ny <size>
Copy "size" pixels in the Y dimension, centered on the middle in Y.
.TP
.B -nz <size>
Copy "size" pixels in the Z dimension, centered on the middle in Z.
.TP
.B -sz <S0,S1>
Scale to bytes, determining the optimal scaling to bytes by analyzing
intensities from sections S0 to S1, inclusive.  Coordinates are treated as
coming from a flipped volume only if the
.B -f
option is given.  Slices are numbered from 1 regardless of whether the
.B -i
option is used.
.TP
.B -s <S0,S1>
Scale to bytes, determining the optimal scaling to bytes by analyzing
intensities from sections S0 to S1, inclusive, in a flipped volume (legacy
behavior).
.TP
.B -sx <X0,X1>
.TP
.B -sy <Y0,Y1>
Analyze the region from X0 to X1 in X, or from Y0 to Y1 in Y, inclusive, in
determining the scaling to bytes.
.TP
.B -c <black,white>
Scale to bytes, with relative intensities between "black" and "white" (on a
scale of 0 to 255) stretched to occupy the full range of byte values.
.TP
.B -mm <min,max>
Scale to integers (mode 1), so that the current minimum and maximum of the file
would be scaled to the given values of minimum and maximum.  Newstack(1) is
run with the -scale option and the entered values.  This option would be used
to scale from mode 2 (floating point) to mode 1.
.TP
.B -yz
Flip Y and Z in the output volume by first creating a temporary trimmed volume
with newstack then running "clip flipyz" on this volume to create the final
output file.
.TP
.B -rx
Rotate the output volume by -90 degrees around the X axis, by first creating a
temporary trimmed volume
with newstack then running "clip rotx" on this volume to create the final
output file.  The slices will look the same as with the
.B -yz
option but rotating instead
of flipping will preserve the handedness of structures.
.TP
.B -i
Interpret 
.B -x,
.B -y,
.B -z,
.B -sx,
and
.B -sy
entries as index coordinates numbered from 0, rather than as 3dmod coordinates
numbered from 1.
.TP
.B -f
Interpret
.B -y,
.B -z,
.B -ny,
.B -nz,
.B -sy,
and
.B -sz
entries as referring to a flipped volume, with Y and Z transposed.
.TP
.B -k
Keep the origin the same in the output from Newstack(1) instead of passing it
the -origin option to adjust the origin for the location of the subvolume
being created.  This option can be used to reproduce a volume created with 
earlier versions of IMOD.
.TP 
.B -P
Output process ID.
.SH FILES
If the output file already exists a backup image
of the original is created
with the ~ extension.
.SH AUTHOR
David Mastronarde  <mast@colorado.edu>
.SH SEE ALSO
newstack(1), findcontrast(1)
